(* From Section 7 of the book *)

open Algo
open State

let (init_state: int -> string -> 'st) =
  fun _ pid ->
  {
    pid = pid;
    input = Random.int 100;
    par = Random.int (max_degree ());
    sub = Random.int 100;
    res = Random.int 100
    }   

let rec (children: 'st neighbor list -> 'st list) =
  fun nl ->
  match nl with
    [] -> []  (*if the current node p is parent of his neighbor n then n is a child of p*)
  | n::liste -> if ((reply n) = (state n).par) then (state n)::(children liste) else children liste

let rec (max: int list -> int -> int) =
  fun l mem ->
  match l with
    [] -> mem
  | i::listi -> if (i>mem) then (max listi i) else (max listi mem)

let rec (sum: int list -> int) = fun l -> List.fold_left (+) 0 l
               
let (sum_sub: 'st neighbor list -> int) =
  fun nl ->
  sum (List.map (fun st -> st.sub) (children nl))
               
      
let (enable_f: 'st -> 'st neighbor list -> action list) =
  fun p nl ->
  if p.sub <> (p.input + (sum_sub nl)) then ["S"]
  else if ((p.par =  -1) && (p.res <> p.sub)) then ["RR"]
  else if ((p.par <> -1) && (p.res <> max [(state (List.nth nl p.par)).res; p.sub] 0)) then ["RP"]
  else []

let (step_f : 'st -> 'st neighbor list -> action -> 'st ) =
  fun p nl a ->
  let sumsub = sum_sub nl in
  match a with
  | "S"  -> {p with sub = (p.input + sumsub)}
  | "RR" -> {p with res = p.sub}
  | "RP" -> {p with res = max [(state (List.nth nl p.par)).res; p.sub] 0}
  | _ -> assert false

